#include "egghack.h"

struct luser_t {
  char *name;
  char *pass;
  char *flags;
};

/* they are all-dynamic, and i dont free them. why? cos it isnt necessary */

struct luser_t eggusers[1024];
/* its static. i dont want to waste time modifying it to dynamic or
** linked list etc
*/


int store_user(char*, char*, char*);

int bruteforce_user(char*);
/* as parameters it takes the pass to crack
** if success it returns index to eggusers to the user
** who uses this pass
*/
int egghack(FILE*);
/* this just takes the global eggusers variable
** and as parameter the dict file fn
*/

int main (int argc, char *argv[])
{
  FILE *u_fn;
  FILE *d_fn;
  char ibuf[8192];
  printf ("egghack project ver %s by hrnt / hydrogen / X ORG\n", EGGHACKVER);
  if (argc < 2)
    {
      printf ("syntax: %s <dictfile> <userfile>\n", argv[0]);
      printf ("if you don't specify dictfile, stdin is used\n");
      return -1;
    }
  if ((d_fn = (argc == 2) ? stdin : fopen (argv[1], "r")) == NULL)
    {
      perror ("opening dict file");
      return -1;
    }
  if ((u_fn = fopen ((argc == 2) ? argv[1] : argv[2], "r")) == NULL)
    {
      perror ("opening user file");
      return -1;
    }
  printf ("opened both userfile and dict file\n");
  memset (&ibuf, 0, sizeof (ibuf));
  fscanf (u_fn, "%s", ibuf);
  if (!strcmp (ibuf, "#3v:"))
    crack_115 (u_fn, d_fn);
  if (!strcmp (ibuf, "#4v:"))
    crack_13x (u_fn, d_fn);
  printf ("error - userfile format not detected\n");
  exit(-1);
}

int crack_115 (FILE * u_fn, FILE * d_fn)
{
  char us_nick[512];
  char ibuf[512];
  char ibuf2[512];
  char ibuf3[512];
  char us_pass[512];
  char us_flags[128];
  char hack_pass[512];
  memset (&us_nick, 0, sizeof (us_nick));
  memset (&ibuf, 0, sizeof (ibuf));
  memset (&us_pass, 0, sizeof (us_pass));
  memset (&us_flags, 0, sizeof (us_flags));

  printf ("detected 3v userfile - 1.1.5 style\n");
  while (!feof (u_fn) && fgetc (u_fn) != '\n') { /* kLudGe n stUFf */ }
  /* i know ^^ this is lame but bleh, i wrote this in hurry :) */

  while (!feof (u_fn))
    {
      memset (&ibuf, 0, sizeof (ibuf));
      memset (&us_pass, 0, sizeof (us_pass));
      /* bzero is deprecated :) */


      fscanf (u_fn, "%s %s %s", ibuf, ibuf2, ibuf3);
      if (ibuf == NULL)
	{
	  perror ("parsing the file fscanf()");
	  exit (1);
	}

      while (!feof (u_fn) && fgetc (u_fn) != '\n') {}
      
      if (
	  (ibuf[0] != ':') && 
	  (ibuf[0] != ' ') &&
	  (ibuf[0] != '.') &&
	  (ibuf[0] != '!') && 
	  (ibuf[0] != '\0')) /* faster than strlen() */
	
	
	{
	  if ((ibuf[0] != '-') && 
	      (ibuf2[0] == '+'))
	    {
	      strncpy (us_nick, ibuf, (sizeof (us_nick) - 1));
	      strncpy (us_pass, ibuf2, (sizeof (us_pass) - 1));
	      strncpy (us_flags, ibuf3, (sizeof (us_flags) - 1));
	      memset (hack_pass, 0, sizeof (hack_pass));
	      store_user(us_nick,
			 us_pass, 
			 (us_flags[0] != '-') ? us_flags : "none");

	    }
	}
    }

  egghack(d_fn);

  exit (0);
}
int crack_13x (FILE * u_fn, FILE * d_fn)
{
  char us_nick[512];
  char ibuf[512];
  char ibuf2[512];
  char ibuf3[512];
  char us_pass[512];
  char us_flags[128];
  char hack_pass[512];
  memset (&us_nick, 0, sizeof (us_nick));
  memset (&ibuf, 0, sizeof (ibuf));
  memset (&us_pass, 0, sizeof (us_pass));
  memset (&us_flags, 0, sizeof (us_flags));

  printf ("detected 4v userfile, 1.3.x style\n");
  while (!feof (u_fn) && fgetc (u_fn) != '\n')
    {
    }

  while (!feof (u_fn))
    {
      memset (&ibuf, 0, sizeof (ibuf));
      memset (&us_pass, 0, sizeof (us_pass));

      fscanf (u_fn, "%s %s %s", ibuf, ibuf2, ibuf3);
      if (ibuf == NULL)
	{
	  perror ("parsing the file fscanf()");
	  exit (1);
	}

      while ((!feof (u_fn)) && 
	     (fgetc (u_fn) != '\n'))
	{
	}

      if ((ibuf[0] != ':') &&
	  (ibuf[0] != ' ') &&
	  (ibuf[0] != '!') &&
	  (ibuf[0] != '\0'))
	{
	  if (ibuf[0] != '-')
	    {
	      strncpy (us_nick, ibuf, (sizeof (us_nick) - 1));
	      strncpy (us_flags, ibuf3, (sizeof (us_flags) - 1));
	    }
	  if (ibuf[0] == '-')
	    {
	      if ((!strcmp (ibuf, "--PASS")) && 
		  (ibuf2[0] == '+'))
		{
		  strncpy (us_pass, ibuf2, (sizeof (us_pass) - 1));
		  memset (hack_pass, 0, sizeof (hack_pass));
		  store_user(us_nick, us_pass,
			     (us_flags[0] != '-') ? us_flags : "none"); 
		}
	    }
	}
    }
  egghack(d_fn);

  exit (0);
}



int store_user(char *useri, char *passu, char *flagut)
{
  static int usptr;
  if ((useri==NULL) ||
      (passu==NULL) ||
      (flagut==NULL))
    return usptr;
  if (eggusers[0].name == NULL)
    usptr=0;
		
  eggusers[usptr].name = malloc(strlen(useri)+1);
  eggusers[usptr].pass = malloc(strlen(passu)+1);
  eggusers[usptr].flags = malloc(strlen(flagut)+1);
  strcpy(eggusers[usptr].name,useri);
  strcpy(eggusers[usptr].pass,passu);
  strcpy(eggusers[usptr].flags,flagut);
  return usptr++;
}

int egghack(FILE *fn)
{

  int i=0;
  char dict_pass[256];
  char hacked_pass[256];
  int p;
  lseek(fn,0L, SEEK_SET);
  while (!feof(fn))
    {
      fscanf(fn, "%s %s", dict_pass, hacked_pass);
      if ((p=bruteforce_user(dict_pass)) != -1)
	{
	  printf("handle: %-15spass: %-20sflags: %-10s\n", eggusers[p].name, hacked_pass, eggusers[p].flags);	
	}
    }
  if (!bruteforce_user(NULL))
    printf("sorry, couldn't hack any users :(\n");
}

int bruteforce_user (char *passstr)
{
  static int hacked=0;
  int moo,izz;
  izz = store_user(NULL, NULL, NULL);
  if (passstr == NULL)
    return hacked;	
  for (moo=0;moo<izz;moo++)
    {
      if (!strcmp(eggusers[moo].pass, passstr))
	{
	  strcpy(eggusers[moo].pass, "-");
	  hacked++;
	  return moo;
	}
    }
  return -1;
}
